## org.eclipse.emf.compare.diff.engine
Interface IDiffEngine

All Known Implementing Classes:
  GenericDiffEngine

    public interface IDiffEngine

A Diff engine has the responsability to provide a diff (or delta) model from a matching model.

Method Summary
`DiffModel` `doDiff(MatchModel match)` Return a diffmodel created using the match model.
`DiffModel` `doDiff(MatchModel match, boolean threeWay)` Return a diffmodel created using the match model.
`DiffModel` `doDiffResourceSet(MatchModel match, boolean threeWay, org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer crossReferencer)` Return a diffmodel created using the given match model.
`void` `reset()` This will be called with each access from the service to the singleton instance of this engine.

Method Detail

### doDiff

    DiffModel doDiff(MatchModel match)

  Return a diffmodel created using the match model. This implementation is a generic and simple one.

  Parameters:
    `match` - The matching model.
  Returns:
    The corresponding diff model.

### doDiff

    DiffModel doDiff(MatchModel match,
                     boolean threeWay)

  Return a diffmodel created using the match model. This implementation is a generic and simple one.

  Parameters:
    `match` - the matching model
    `threeWay` - `True` if we're computing a three way comparison, `False` otherwise.
  Returns:
    the corresponding diff model

### doDiffResourceSet

    DiffModel doDiffResourceSet(MatchModel match,
                                boolean threeWay,
                                org.eclipse.emf.ecore.util.EcoreUtil.CrossReferencer crossReferencer)

  Return a diffmodel created using the given match model. `crossReferencer` has been initialized on the whole MatchResourceSet.

  Parameters:
    `match` - the matching model
    `threeWay` - `True` if we're computing a three way comparison, `False` otherwise.
    `crossReferencer` - This cross referencer has been initialized with the whole MatchResourceSet and can be used to retrieve matched EObjects towards other resources.
  Returns:
    the corresponding diff model

### reset

    void reset()

  This will be called with each access from the service to the singleton instance of this engine. Clients should dispose of all caches and recorded information within this method's implementation.

Copyright 2006 IBM Corporation and others. All Rights Reserved.